<template>
  <a17-inputframe :error="error" :note="note" :locale="locale" @localize="updateLocale" :label="label" :name="name" :required="required">
    <div class="form__field" :class="textfieldClasses">
      <input type="hidden" :name="`${name}__lat`" :value="lat"/>
      <input type="hidden" :name="`${name}__lng`" :value="lng"/>
    </div>
    <div style="height: 400px">
      <l-map ref="myMap" :center="center" :zoom="zoom">
        <l-tile-layer :url="url"></l-tile-layer>
        <l-marker ref="centerMarker" :latLng="center" :draggable="!disabled"></l-marker>
      </l-map>
    </div>
  </a17-inputframe>
</template>

<script>
/**
 * This file, unlike most of the code in this codebase, is under Apache 2.0 license.
 * https://www.apache.org/licenses/LICENSE-2.0
 * We gratefully acknowledge the work of the Area17/Twill team in creating
 * the original LocationField.vue
 */

  import isEqual from 'lodash/isEqual'
  import InputMixin from '@/mixins/input'
  import FormStoreMixin from '@/mixins/formStore'
  import InputframeMixin from '@/mixins/inputFrame'
  import LocaleMixin from '@/mixins/locale'

  /* global google */

  export default {
    name: 'A17Oslocationfield',
    mixins: [InputMixin, InputframeMixin, LocaleMixin, FormStoreMixin],
    props: {
      type: {
        type: String,
        default: 'text'
      },
      disabled: {
        type: Boolean,
        default: false
      },
      zoom: {
        type: Number,
        default: 9
      },
      initialLat: {
        type: Number,
        default: null
      },
      initialLng: {
        type: Number,
        default: null
      }
    },
    data: function () {
      return {
        map: null,
        url: 'https://{s}.tile.openstreetmap.org/{z}/{x}/{y}.png',
        mapObject: undefined,
        markers: [],
        lat: this.initialLat,
        lng: this.initialLng,
        focused: false
      }
    },
    components: {
      'l-map': window.Vue2Leaflet.LMap,
      'l-tile-layer': window.Vue2Leaflet.LTileLayer,
      'l-marker': window.Vue2Leaflet.LMarker
    },
    computed: {
      center: function () {
        if (this.lat && this.lng) {
          return [this.lat, this.lng]
        }
        return [0, 0]
      },
      value: {
        get () {
          return [this.lat, this.lng]
        },
        set (value) {
          if (value) {
            const coord = value
            this.lat = parseFloat(coord[0])
            this.lng = parseFloat(coord[1])
          }
        }
      },
      textfieldClasses: function () {
        return {
          's--focus': this.focused,
          's--disabled': this.disabled
        }
      }
    },
    methods: {
      updateFromStore: function (newValue) { // called from the formStore mixin
        if (!isEqual(newValue, this.value)) {
          this.value = newValue
        }
      },
      onFocus: function (event) {
        this.focused = true
        this.beforeFocusLocation = this.lat + '|' + this.lng

        this.$emit('focus')
      },
      onBlur: function (event) {
        this.focused = false

        this.clearMarkers()
        this.lat = this.initialLat
        this.lng = this.initialLng

        this.$emit('blur')
      },
      onInput: function (event) {
        const newValue = event.target.value

        this.$emit('change', newValue)
      },
      clearMarkers: function () {
        for (let i = 0; i < this.markers.length; i++) {
          if (this.markers[i]) {
            this.markers[i].setMap(null)
          }
        }
        this.markers = []
      },
      clearLatLng: function () {
        this.lat = 0
        this.lng = 0
      },
      addMarker: function (location) {
        const marker = new google.maps.Marker({
          position: location,
          map: this.map
        })

        this.markers.push(marker)
      },
      setLatLng: function (latlng) {
        this.lat = latlng.lat
        this.lng = latlng.lng

        if (this.lat + '|' + this.lng !== this.beforeFocusLocation) {
          this.$emit('change', [this.lat, this.lng])
          this.beforeFocusLocation = this.lat + '|' + this.lng
          this.saveIntoStore([this.lat, this.lng])
        }
      },
      initMap: function () {
        this.mapObject = this.$refs.myMap.mapObject
        var centerMarker = this.$refs.centerMarker.mapObject

        centerMarker.on('dragend', function (event) {
          var center = event.target.getLatLng()
          if (!this.disabled) {
            this.setLatLng(center)
          }
        }.bind(this))
        this.centerMarker = centerMarker
      }
    },
    mounted: function () {
      this.$nextTick(() => {
        this.initMap()
      })
    },
    beforeDestroy: function () {
      // if (typeof google !== 'undefined') google.maps.event.clearListeners(this.autocompletePlace, 'place_changed', this.onPlaceChanged)
    }
  }
</script>

<style lang="scss" scoped>

  .form__field {
    display: flex;
    align-items: center;
    padding: 0 15px;

    input {
      padding: 0;
    }

  }

</style>
